#include "Python.h"

extern void display_info(char *, char *, char *);
extern int calc_year(int, int, int);

static PyObject *wrapper_display_info(PyObject *self, PyObject *args, PyObject *kwargs)
{
   char *user = "None";
   char *domain = "None";
   char *country = "None";
   static char *keywords[] = {"user","domain","country",NULL};
   
   if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|sss", keywords, &user, &domain, &country)){
      return NULL;
   }

   display_info(user, domain, country);
   return Py_BuildValue("");
}

static PyObject *wrapper_calc_year(PyObject *self, PyObject *args) {
   int f_year, m_year, l_year, result;
   if (!PyArg_ParseTuple(args, "iii", &f_year, &m_year, &l_year)) {
       return NULL;
   }
   result = calc_year(f_year, m_year, l_year);
   return Py_BuildValue("i", result);
}

static PyMethodDef wrappermethods[] = {
   {"display_info", wrapper_display_info, METH_VARARGS|METH_KEYWORDS},
   {"calc_year", wrapper_calc_year, METH_VARARGS},
   {NULL, NULL}
};

DL_EXPORT(void) initwrapper() {
   Py_InitModule("wrapper", wrappermethods);
}
