# File: parkinglot.py

from win32com.server.exception import Exception
import win32com.server.util

class ParkingServer:
        _reg_clsid_ = '{BD2CB7C0-3BB9-11D4-804E-0050041A5111}'
        _reg_progid_ = 'Python.ParkingServer'
        _public_methods_ = ['ParkVehicle', 'UnparkVehicle',
			    'GetVehiclesCount', 'IdentifyVehicle',
			    'GetLocationList']
	
	def __init__(self):
		self.Vehicles = [Vehicle()]
	
	def ParkVehicle(self, floor=1, model="", license="", color=""):
		VehicleToPark = Vehicle()
		VehicleToPark.floor = floor
		VehicleToPark.model = str(model)
		VehicleToPark.license = str(license)
		VehicleToPark.color = str(color)
		self.Vehicles.append(VehicleToPark) 			
		 
	def UnparkVehicle(self,index):
		del self.Vehicles[index]

	def IdentifyVehicle(self, index):
		return win32com.server.util.wrap(self.Vehicles[index])
		
	def GetLocationList(self):
		return map(lambda x:x.GetLocation(), self.Vehicles)
	
	def GetVehiclesCount(self):
		return len(self.Vehicles)

class Vehicle:
        _reg_clsid_ = '{BD2CB7C1-3BB9-11D4-804E-0050041A5111}'
        _reg_progid_ = 'Python.Vehicle'
        _public_methods_ = ['GetLocation']
        _public_attrs_ = ['floor','model','license','color']
				
	def __init__(self, floor=1, model = 'Dodge Neon', license = 'LKS-92020', color = 'Red'):
		self.floor = floor
		self.model = model
		self.license = license
		self.color = color
	
	def GetLocation(self):
		return 'The %s %s license %s is on the %d floor' % \
                  (self.color, self.model, self.license, self.floor)

def RegisterClasses():
     print "Registering COM servers..."
     import win32com.server.register

     win32com.server.register.UseCommandLine(ParkingServer)
     print "ParkingServer Class registered."

     win32com.server.register.UseCommandLine(Vehicle)
     print "Vehicle Class registered."
	
def UnRegisterClasses():
     print "Unregistering COM server..."
     import win32com.server.register

     win32com.server.register.UnregisterClasses(ParkingServer)
     print "ParkingServer Class unregistered."

     win32com.server.register.UnregisterClasses(Vehicle)
     print "Vehicle Class unregistered."

if __name__=='__main__':
	import sys
	if "-unregister" in sys.argv:
            UnRegisterClasses()
	else:
            RegisterClasses()
